#include <ros/ros.h>
// PCL specific includes
#include <geometry_msgs/PoseStamped.h>
#include <geometry_msgs/PointStamped.h>
#include <sensor_msgs/PointCloud2.h>
#include <pcl_conversions/pcl_conversions.h>
#include <pcl/point_cloud.h>
#include <pcl/point_types.h>
#include <pcl/filters/conditional_removal.h>
#include <pcl/PCLPointCloud2.h>
#include <pcl/conversions.h>
#include <pcl_ros/transforms.h>
#include <pcl/filters/radius_outlier_removal.h>
#include <pcl/keypoints/narf_keypoint.h>
#include <pcl/range_image/range_image.h>
#include <pcl/features/range_image_border_extractor.h>
#include <pcl/keypoints/harris_3d.h>
#include <pcl/visualization/range_image_visualizer.h>
#include <pcl/visualization/pcl_visualizer.h>
#include <pcl/filters/voxel_grid.h>
#include <pcl/features/narf_descriptor.h>
#include <pcl/keypoints/sift_keypoint.h>
#include <pcl/keypoints/iss_3d.h>
#include <pcl/registration/correspondence_rejection_sample_consensus.h>
#include <pcl/registration/correspondence_estimation.h>
#include <pcl/features/normal_3d_omp.h>
#include <pcl/features/fpfh_omp.h>
#include <pcl/registration/icp.h>
#include <pcl/registration/gicp.h>
#include <pcl/registration/ndt.h>
#include <pcl/registration/correspondence_rejection_distance.h>
#include <pcl/features/usc.h>
#include <pcl/features/3dsc.h>
#include <pcl/features/shot_omp.h>
#include <pcl/registration/correspondence_rejection_one_to_one.h>
#include <pcl/filters/extract_indices.h>
#include <pcl/visualization/pcl_visualizer.h>
#include <pcl/features/pfh.h>
#include <pcl/filters/extract_indices.h>
#include <pcl/io/pcd_io.h>

#include "my_pcl_tutorial/NorthEastHeading.h"

#include <math.h>
#include <unistd.h>
#include <string.h>
#include <sstream>
#include <fstream>
#include <iostream>

ros::Publisher pub;
ros::Publisher pub2;
ros::Publisher pub3;
ros::Publisher pub4;
ros::Publisher pub5;
ros::Publisher pub6;
ros::Publisher pub7;
ros::Publisher pub8;
ros::Publisher pub9;
ros::Publisher pub10;
ros::Publisher pub11;

ofstream file;
ofstream odom_file;

int iss_points=0;
int narf_points=0;
int siftz_points=0;
int counter=1;
int counter2=1;
int slam_counter=1;
int map_counter=0;

int total_cor = 0;
int total_points = 0;
int total_clouds = 0;


double north = 0.0;
double east = 0.0;
double theta = 0.0;
bool nav_online = false;
double distance_since_last = 0.0;
double total_distance = 0.0;
double prev_north = -0.65;
double prev_east = 2.8;
bool send_message = false;

geometry_msgs::PointStamped point_msg;
geometry_msgs::Point point; 
pcl::PointCloud<pcl::PointXYZI>::Ptr source_cor (new pcl::PointCloud<pcl::PointXYZI> ());
pcl::PointCloud<pcl::PointXYZI>::Ptr loop (new pcl::PointCloud<pcl::PointXYZI> ());
pcl::PointCloud<pcl::PointXYZI>::Ptr loop2 (new pcl::PointCloud<pcl::PointXYZI> ());

Eigen::Vector3f nav_trans;
Eigen::Matrix3f nav_rot;
Eigen::Vector3f map_translation;
Eigen::Vector3f map_total_translation;

// pcl::visualization::PCLVisualizer::Ptr viewer (new pcl::visualization::PCLVisualizer ("3D Viewer"));

pcl::PointCloud<pcl::PointXYZI>::Ptr map (new pcl::PointCloud<pcl::PointXYZI>);
pcl::PointCloud<pcl::PointXYZI>::Ptr current_map (new pcl::PointCloud<pcl::PointXYZI>);
pcl::PointCloud<pcl::PointXYZI>::Ptr loop_closure_map (new pcl::PointCloud<pcl::PointXYZI>);
pcl::PointCloud<pcl::PointXYZI>::Ptr loop_closure_map2 (new pcl::PointCloud<pcl::PointXYZI>);
pcl::PointCloud<pcl::SHOT352>::Ptr feature_map (new pcl::PointCloud<pcl::SHOT352>);
// pcl::PointCloud<pcl::FPFHSignature33>::Ptr feature_map (new pcl::PointCloud<pcl::FPFHSignature33>);
// pcl::PointCloud<pcl::ShapeContext1980>::Ptr feature_map (new pcl::PointCloud<pcl::ShapeContext1980>);
// pcl::PointCloud<pcl::PFHSignature125>::Ptr feature_map (new pcl::PointCloud<pcl::PFHSignature125>);


pcl::PointCloud<pcl::PointXYZI>::Ptr source_cloud (new pcl::PointCloud<pcl::PointXYZI>);
pcl::PointCloud<pcl::PointXYZI>::Ptr target_cloud (new pcl::PointCloud<pcl::PointXYZI>);
pcl::PointCloud<pcl::PointXYZI>::Ptr source_keypoints (new pcl::PointCloud<pcl::PointXYZI>);
pcl::PointCloud<pcl::PointXYZI>::Ptr target_keypoints (new pcl::PointCloud<pcl::PointXYZI>);
pcl::PointCloud<pcl::PointXYZI>::Ptr loop_keypoints (new pcl::PointCloud<pcl::PointXYZI>);
pcl::PointCloud<pcl::PointXYZI>::Ptr trans_keypoints (new pcl::PointCloud<pcl::PointXYZI>);
pcl::PointCloud<pcl::PointXYZI>::Ptr filtered_loop_keypoints (new pcl::PointCloud<pcl::PointXYZI>);
pcl::PointCloud<pcl::PointXYZI>::Ptr later_loop_keypoints (new pcl::PointCloud<pcl::PointXYZI>);
pcl::PointCloud<pcl::PointXYZI>::Ptr full_map (new pcl::PointCloud<pcl::PointXYZI>);
// pcl::PointCloud<pcl::FPFHSignature33>::Ptr source_cloud_keypoints (new pcl::PointCloud<pcl::FPFHSignature33>);
// pcl::PointCloud<pcl::FPFHSignature33>::Ptr target_cloud_keypoints (new pcl::PointCloud<pcl::FPFHSignature33>);
// pcl::PointCloud<pcl::ShapeContext1980>::Ptr source_cloud_keypoints (new pcl::PointCloud<pcl::ShapeContext1980>);
// pcl::PointCloud<pcl::ShapeContext1980>::Ptr target_cloud_keypoints (new pcl::PointCloud<pcl::ShapeContext1980>);
pcl::PointCloud<pcl::SHOT352>::Ptr source_cloud_keypoints (new pcl::PointCloud<pcl::SHOT352>);
pcl::PointCloud<pcl::SHOT352>::Ptr target_cloud_keypoints (new pcl::PointCloud<pcl::SHOT352>);
pcl::PointCloud<pcl::SHOT352>::Ptr loop_cloud_keypoints (new pcl::PointCloud<pcl::SHOT352>);
pcl::PointCloud<pcl::SHOT352>::Ptr filtered_loop_cloud_keypoints (new pcl::PointCloud<pcl::SHOT352>);
pcl::PointCloud<pcl::SHOT352>::Ptr later_loop_cloud_keypoints (new pcl::PointCloud<pcl::SHOT352>);
// pcl::PointCloud<pcl::PFHSignature125>::Ptr source_cloud_keypoints (new pcl::PointCloud<pcl::PFHSignature125>);
// pcl::PointCloud<pcl::PFHSignature125>::Ptr target_cloud_keypoints (new pcl::PointCloud<pcl::PFHSignature125>);
Eigen::Matrix4f since_last_transformation; 
Eigen::Matrix3f total_rotation;
Eigen::Vector3f total_translation;
Eigen::Matrix3f since_last_rotation;
Eigen::Vector3f since_last_translation;

double
computeCloudResolution (const pcl::PointCloud<pcl::PointXYZI>::ConstPtr& cloud)
{
  double res = 0.0;
  int n_points = 0;
  int nres;
  std::vector<int> indices (2);
  std::vector<float> sqr_distances (2);
  pcl::search::KdTree<pcl::PointXYZI> tree;
  tree.setInputCloud (cloud);

  for (std::size_t i = 0; i < cloud->size (); ++i)
  {
    if (! std::isfinite ((*cloud)[i].x))
    {
      continue;
    }
    //Considering the second neighbor since the first is the point itself.
    nres = tree.nearestKSearch (i, 2, indices, sqr_distances);
    if (nres == 2)
    {
      res += sqrt (sqr_distances[1]);
      ++n_points;
    }
  }
  if (n_points != 0)
  {
    res /= n_points;
  }
  return res;
}

void ndt(const pcl::PointCloud<pcl::PointXYZI>::Ptr& point_cloud_ptr){
  if (counter%5==4) {
    // for(pcl::PointCloud<pcl::PointXYZI>::iterator it = source_cloud->begin(); it!= source_cloud->end(); it++){
    //     it->z = 0;
    // }

    // for(pcl::PointCloud<pcl::PointXYZI>::iterator it = target_cloud->begin(); it!= target_cloud->end(); it++){
    //     it->z = 0;
    // }
    source_cloud = point_cloud_ptr;
    pcl::NormalDistributionsTransform<pcl::PointXYZI, pcl::PointXYZI> ndt;
    ndt.setTransformationEpsilon (0.1);
    // ndt.setStepSize (0.1);
    ndt.setResolution (1);
    ndt.setMaximumIterations (10);
    ndt.setInputSource (source_cloud);
    ndt.setInputTarget (target_cloud);  
    pcl::PointCloud<pcl::PointXYZI>::Ptr output_cloud (new pcl::PointCloud<pcl::PointXYZI>);
    // Eigen::AngleAxisf init_rotation (0, Eigen::Vector3f::UnitZ ());
    // Eigen::Translation3f init_translation (0, 0, 0);
    // Eigen::Matrix4f init_guess = (init_translation * init_rotation).matrix ();
    // ndt.align (*output_cloud, init_guess);
    ndt.align(*output_cloud);
    std::cout << "Normal Distributions Transform has converged:" << ndt.hasConverged ()
            << " score: " << ndt.getFitnessScore () << std::endl;
    std::cout << "Transformation from last picture: \n" << ndt.getFinalTransformation () << std::endl;

    // pcl::IterativeClosestPoint<pcl::PointXYZ, pcl::PointXYZ> icp;
    // icp.setInputSource(source_cloud);
    // icp.setInputTarget(cloud_out);
    // pcl::PointCloud<pcl::PointXYZ> Final;
    // icp.align(Final);
    // std::cout << "has converged:" << icp.hasConverged() << " score: " <<
    // icp.getFitnessScore() << std::endl;
    // std::cout << icp.getFinalTransformation() << std::endl;

    // total_transformation = ndt.getFinalTransformation () * total_transformation;
    // std::cout << "Total transformation: \n" << total_transformation << std::endl;
  }

  target_cloud = point_cloud_ptr;

  counter++;
}

void narf(const pcl::PointCloud<pcl::PointXYZI>::Ptr& point_cloud_ptr){
  float angular_resolution = 0.5f;
  float support_size = 0.1f;
  pcl::RangeImage::CoordinateFrame coordinate_frame = pcl::RangeImage::CAMERA_FRAME;
  bool setUnseenToMaxRange = true;
  bool rotation_invariant = true;
  
  pcl::PointCloud<pcl::PointXYZI>& point_cloud = *point_cloud_ptr;
  Eigen::Affine3f scene_sensor_pose (Eigen::Affine3f::Identity ());
  scene_sensor_pose = Eigen::Affine3f (Eigen::Translation3f (point_cloud.sensor_origin_[0],
                                                               point_cloud.sensor_origin_[1],
                                                               point_cloud.sensor_origin_[2])) *
                        Eigen::Affine3f (point_cloud.sensor_orientation_);
  angular_resolution = pcl::deg2rad (angular_resolution);
  float noise_level = 0.0;
  float min_range = 0.0f;
  int border_size = 1;
  pcl::RangeImage::Ptr range_image_ptr (new pcl::RangeImage);
  pcl::RangeImage& range_image = *range_image_ptr;   
  range_image.createFromPointCloud (point_cloud, angular_resolution, pcl::deg2rad (360.0f), pcl::deg2rad (180.0f),
                                   scene_sensor_pose, coordinate_frame, noise_level, min_range, border_size);
  if (setUnseenToMaxRange){
      range_image.setUnseenToMaxRange();
  }   

  pcl::RangeImageBorderExtractor range_image_border_extractor;
  pcl::NarfKeypoint narf_keypoint_detector;
  narf_keypoint_detector.setRangeImageBorderExtractor (&range_image_border_extractor);
  narf_keypoint_detector.setRangeImage (&range_image);
  narf_keypoint_detector.getParameters ().support_size = support_size;
  
  pcl::PointCloud<int> keypoint_indices;
  narf_keypoint_detector.compute (keypoint_indices);

  // std::vector<int> keypoint_indices2;
  // keypoint_indices2.resize (keypoint_indices.points.size ());
  // for (unsigned int i=0; i<keypoint_indices.size (); ++i) // This step is necessary to get the right vector type
  //   keypoint_indices2[i]=keypoint_indices.points[i];
  // pcl::NarfDescriptor narf_descriptor (&range_image, &keypoint_indices2);
  // narf_descriptor.getParameters ().support_size = support_size;
  // narf_descriptor.getParameters ().rotation_invariant = rotation_invariant;
  // pcl::PointCloud<pcl::Narf36>::Ptr narf_descriptors (new pcl::PointCloud<pcl::Narf36>);
  // narf_descriptor.compute (*narf_descriptors);
//   std::cout << "Extracted "<<narf_descriptors.size ()<<" descriptors for "
//                       <<keypoint_indices.points.size ()<< " keypoints.\n";

  pcl::PointCloud<pcl::PointXYZI>::Ptr keypoints_ptr (new pcl::PointCloud<pcl::PointXYZI>);
  pcl::PointCloud<pcl::PointXYZI>& keypoints = *keypoints_ptr;
  keypoints.points.resize (keypoint_indices.points.size ());
  for (size_t i=0; i<keypoint_indices.points.size (); ++i)
      keypoints.points[i].getVector3fMap () = range_image.points[keypoint_indices.points[i]].getVector3fMap ();

  keypoints.header.frame_id = point_cloud_ptr->header.frame_id;
  keypoints.header.stamp = point_cloud_ptr->header.stamp;

  // std::cout << "No of NARF points in the result are " << keypoints.points.size () << " and total points are " << narf_points << std::endl;


  pcl::PCLPointCloud2 pcl_pc;
  pcl::toPCLPointCloud2(*keypoints_ptr, pcl_pc);

  pub2.publish (pcl_pc);

  // source_cloud_keypoints = keypoints_ptr;
  // source_cloud = point_cloud_ptr;

  // std::cout << "Size of first image: " << source_cloud_keypoints->size() << " Size of second image: " << target_cloud_keypoints->size() << std::endl;


  // boost::shared_ptr<pcl::Correspondences> correspondences (new pcl::Correspondences);
  // pcl::registration::CorrespondenceEstimation<pcl::PointXYZI, pcl::PointXYZI> corr_est;
  // corr_est.setInputSource (source_cloud);
  // corr_est.setInputTarget (target_cloud);
  // corr_est.determineCorrespondences (*correspondences);

  // std::cout << "Found " << correspondences->size() << " number of correspondences" << std::endl;


  // std::cout << "Size of first image: " << source_cloud->size() << " Size of second image: " << target_cloud->size() << std::endl;

  // pcl::registration::CorrespondenceRejectorSampleConsensus<pcl::PointXYZI> correspondence_rejector;
  // correspondence_rejector.setInputSource(source_cloud);
  // correspondence_rejector.setInputTarget(target_cloud);
  // correspondence_rejector.setInlierThreshold(0.4);
  // correspondence_rejector.setMaximumIterations(1000);
  // correspondence_rejector.setRefineModel(true);
  // correspondence_rejector.setInputCorrespondences(correspondences);

  // boost::shared_ptr<pcl::Correspondences> cor_inliers_ptr (new pcl::Correspondences);
  // correspondence_rejector.getCorrespondences(*cor_inliers_ptr);

  // std::cout << "Correspondences remaining: " << cor_inliers_ptr->size() << std::endl;

  // Eigen::Matrix4f transformation; 
  // transformation = correspondence_rejector.getBestTransformation();

  // std::cout << transformation << std::endl;

  // target_cloud = point_cloud_ptr;

  // if (narf_points!=0){
  //   total_transformation = total_transformation * icp.getFinalTransformation();
  // }
  // std::cout << total_transformation << std::endl;

  narf_points+=keypoints.points.size();

  cout << "Time: " <<  ros::WallTime::now()  << endl;
}

void sift(const pcl::PointCloud<pcl::PointXYZI>::Ptr& point_cloud_ptr){
  const float min_scale = 0.2;
  const int n_octaves = 6;
  const int n_scales_per_octave = 4;
  const float min_contrast = 0.5;
  
  // Estimate the sift interest points using z values from xyz as the Intensity variants
  pcl::SIFTKeypoint<pcl::PointXYZI, pcl::PointWithScale> sift;
  pcl::PointCloud<pcl::PointWithScale> result;
  pcl::search::KdTree<pcl::PointXYZI>::Ptr tree(new pcl::search::KdTree<pcl::PointXYZI> ());
  sift.setSearchMethod(tree);
  sift.setScales(min_scale, n_octaves, n_scales_per_octave);
  sift.setMinimumContrast(min_contrast);
  sift.setInputCloud(point_cloud_ptr);
  sift.compute(result);


  result.header.frame_id = point_cloud_ptr->header.frame_id;
  result.header.stamp = point_cloud_ptr->header.stamp;

  // std::cout << "No of SIFT points in the result are " << result.points.size () << " and total points are " << siftz_points << std::endl;

  pcl::PointCloud<pcl::PointXYZI>::Ptr cloud_temp (new pcl::PointCloud<pcl::PointXYZI>);
  copyPointCloud(result, *cloud_temp);

  siftz_points+=result.points.size();

  cout << "Time: " <<  ros::WallTime::now()  << endl;


  pcl::PCLPointCloud2 pcl_pc;
  pcl::toPCLPointCloud2(*cloud_temp, pcl_pc);

  pub3.publish (pcl_pc);
}

void iss_time(const pcl::PointCloud<pcl::PointXYZI>::Ptr& point_cloud_ptr){
  double iss_gamma_21_ (0.975); 
  double iss_gamma_32_ (0.975);
  double iss_min_neighbors_ (4);
  int iss_threads_ (4);

  double model_resolution = computeCloudResolution(point_cloud_ptr);
  double iss_salient_radius_(6*model_resolution);
  double iss_non_max_radius_(4*model_resolution);
  double iss_normal_radius_(4*model_resolution);
  double iss_border_radius_(model_resolution);

  pcl::PointCloud<pcl::PointXYZI>::Ptr model_keypoints (new pcl::PointCloud<pcl::PointXYZI> ());
  pcl::search::KdTree<pcl::PointXYZI>::Ptr tree (new pcl::search::KdTree<pcl::PointXYZI> ());

  pcl::NormalEstimationOMP<pcl::PointXYZI, pcl::Normal> ne;
  ne.setInputCloud (point_cloud_ptr);
  ne.setSearchMethod (tree);
  pcl::PointCloud<pcl::Normal>::Ptr cloud_normals (new pcl::PointCloud<pcl::Normal>);
  ne.setKSearch (40);
  // ne.setNeighborSearch (4);
  ne.compute (*cloud_normals);

  pcl::ISSKeypoint3D<pcl::PointXYZI, pcl::PointXYZI> iss_detector;
// if (counter % 2 == 1){
  iss_detector.setSearchMethod (tree);
  iss_detector.setSalientRadius (iss_salient_radius_);
  iss_detector.setNonMaxRadius (iss_non_max_radius_);

  iss_detector.setNormalRadius (iss_normal_radius_);
  iss_detector.setBorderRadius (iss_border_radius_);

  iss_detector.setThreshold21 (iss_gamma_21_);
  iss_detector.setThreshold32 (iss_gamma_32_);
  iss_detector.setMinNeighbors (iss_min_neighbors_);
  iss_detector.setNumberOfThreads (iss_threads_);
  iss_detector.setInputCloud (point_cloud_ptr);
  iss_detector.setNormals (cloud_normals);
  iss_detector.compute (*model_keypoints);

  // const float min_scale = 0.2;
  // const int n_octaves = 6;
  // const int n_scales_per_octave = 4;
  // const float min_contrast = 0.5;
  
  // // Estimate the sift interest points using z values from xyz as the Intensity variants
  // pcl::SIFTKeypoint<pcl::PointXYZI, pcl::PointWithScale> sift;
  // pcl::PointCloud<pcl::PointWithScale> result;
  // // pcl::search::KdTree<pcl::PointXYZI>::Ptr tree(new pcl::search::KdTree<pcl::PointXYZI> ());
  // sift.setSearchMethod(tree);
  // sift.setScales(min_scale, n_octaves, n_scales_per_octave);
  // sift.setMinimumContrast(min_contrast);
  // sift.setInputCloud(point_cloud_ptr);
  // sift.compute(result);

  // // pcl::PointCloud<pcl::PointXYZI>::Ptr cloud_temp (new pcl::PointCloud<pcl::PointXYZI>);
  // copyPointCloud(result, *model_keypoints);

  // pcl::HarrisKeypoint3D <pcl::PointXYZI, pcl::PointXYZI> detector;
  // // pcl::PointCloud<pcl::PointXYZI>::Ptr keypoints (new pcl::PointCloud<pcl::PointXYZI>);
  // detector.setNonMaxSupression (true);
  // detector.setInputCloud (point_cloud_ptr);
  // detector.setThreshold (1e-5);
  // detector.setRadius(1.5);
  // detector.setNormals(cloud_normals);
  // detector.setRefine(false);
  // detector.compute (*model_keypoints);

  // float angular_resolution = 0.5f;
  // float support_size = 0.1f;
  // pcl::RangeImage::CoordinateFrame coordinate_frame = pcl::RangeImage::CAMERA_FRAME;
  // bool setUnseenToMaxRange = true;
  // bool rotation_invariant = true;
  
  // pcl::PointCloud<pcl::PointXYZI>& point_cloud = *point_cloud_ptr;
  // Eigen::Affine3f scene_sensor_pose (Eigen::Affine3f::Identity ());
  // scene_sensor_pose = Eigen::Affine3f (Eigen::Translation3f (point_cloud.sensor_origin_[0],
  //                                                              point_cloud.sensor_origin_[1],
  //                                                              point_cloud.sensor_origin_[2])) *
  //                       Eigen::Affine3f (point_cloud.sensor_orientation_);
  // angular_resolution = pcl::deg2rad (angular_resolution);
  // float noise_level = 0.0;
  // float min_range = 0.0f;
  // int border_size = 1;
  // pcl::RangeImage::Ptr range_image_ptr (new pcl::RangeImage);
  // pcl::RangeImage& range_image = *range_image_ptr;   
  // range_image.createFromPointCloud (point_cloud, angular_resolution, pcl::deg2rad (360.0f), pcl::deg2rad (180.0f),
  //                                  scene_sensor_pose, coordinate_frame, noise_level, min_range, border_size);
  // if (setUnseenToMaxRange){
  //     range_image.setUnseenToMaxRange();
  // }   

  // pcl::RangeImageBorderExtractor range_image_border_extractor;
  // pcl::NarfKeypoint narf_keypoint_detector;
  // narf_keypoint_detector.setRangeImageBorderExtractor (&range_image_border_extractor);
  // narf_keypoint_detector.setRangeImage (&range_image);
  // narf_keypoint_detector.getParameters ().support_size = support_size;
  
  // pcl::PointCloud<int> keypoint_indices;
  // narf_keypoint_detector.compute (keypoint_indices);

  // pcl::PointCloud<pcl::PointXYZI>::Ptr keypoints_ptr (new pcl::PointCloud<pcl::PointXYZI>);
  // pcl::PointCloud<pcl::PointXYZI>& keypoints = *model_keypoints;
  // keypoints.points.resize (keypoint_indices.points.size ());
  // for (size_t i=0; i<keypoint_indices.points.size (); ++i)
  //     keypoints.points[i].getVector3fMap () = range_image.points[keypoint_indices.points[i]].getVector3fMap ();

  source_keypoints = model_keypoints;
  source_cloud = point_cloud_ptr;

  // pcl::SHOTEstimationOMP<pcl::PointXYZI, pcl::Normal, pcl::SHOT352> shot;
  // shot.setInputCloud (model_keypoints);
  // shot.setInputNormals (cloud_normals);
  // shot.setSearchMethod (tree);
  // shot.setSearchSurface (point_cloud_ptr);
  // pcl::PointCloud<pcl::SHOT352>::Ptr shotFeatures (new pcl::PointCloud<pcl::SHOT352> ());
  // shot.setRadiusSearch (3.5);
  // shot.compute (*shotFeatures);

  // pcl::FPFHEstimationOMP<pcl::PointXYZI, pcl::Normal, pcl::FPFHSignature33> fpfh;
  // fpfh.setInputCloud (model_keypoints);
  // fpfh.setInputNormals (cloud_normals);
  // fpfh.setSearchMethod (tree);
  // fpfh.setSearchSurface (point_cloud_ptr);
  // pcl::PointCloud<pcl::FPFHSignature33>::Ptr fpfhs (new pcl::PointCloud<pcl::FPFHSignature33> ());
  // fpfh.setRadiusSearch (3.5);
  // fpfh.compute (*fpfhs);

  pcl::PFHEstimation<pcl::PointXYZI, pcl::Normal, pcl::PFHSignature125> pfh;
  pfh.setInputCloud (model_keypoints);
  pfh.setInputNormals (cloud_normals);
  pfh.setSearchMethod (tree);
  pfh.setSearchSurface (point_cloud_ptr);
  pcl::PointCloud<pcl::PFHSignature125>::Ptr pfhs (new pcl::PointCloud<pcl::PFHSignature125> ());
  pfh.setRadiusSearch (3.5);
  pfh.compute (*pfhs);


  // pcl::ShapeContext3DEstimation<pcl::PointXYZI, pcl::Normal, pcl::ShapeContext1980> shape_context;

  // shape_context.setInputCloud (source_keypoints);
  // shape_context.setInputNormals (cloud_normals);
  // shape_context.setSearchSurface (source_cloud);
  // shape_context.setSearchMethod (tree);
  // pcl::PointCloud<pcl::ShapeContext1980>::Ptr shape_context_features(new pcl::PointCloud<pcl::ShapeContext1980>());
  // shape_context.setRadiusSearch (3.5);
  // shape_context.setPointDensityRadius (0.7);
  // shape_context.setMinimalRadius (0.35);
  // shape_context.compute (*shape_context_features);

  // boost::shared_ptr<pcl::Correspondences> correspondences (new pcl::Correspondences);
  // pcl::registration::CorrespondenceEstimation<pcl::PointXYZI, pcl::PointXYZI> corr_est;
  // corr_est.setInputSource (source_keypoints);
  // corr_est.setInputTarget (target_keypoints);
  // corr_est.determineCorrespondences (*correspondences);

  // boost::shared_ptr<pcl::Correspondences> new_correspondences (new pcl::Correspondences);
  // pcl::registration::CorrespondenceRejectorDistance rej;
  // rej.setInputSource<pcl::PointXYZI> (source_keypoints);
  // rej.setInputTarget<pcl::PointXYZI> (target_keypoints);
  // rej.setMaximumDistance (7);    // 7m
  // rej.setInputCorrespondences (correspondences);
  // rej.getCorrespondences (*new_correspondences);

  // // std::cout << "Found " << new_correspondences->size() << " number of new correspondences" << std::endl;

  // // std::cout << "Size of first image: " << source_cloud->size() << " Size of second image: " << target_cloud->size() << std::endl;

  // pcl::registration::CorrespondenceRejectorSampleConsensus<pcl::PointXYZI> correspondence_rejector;
  // correspondence_rejector.setInputSource(source_keypoints);
  // correspondence_rejector.setInputTarget(target_keypoints);
  // correspondence_rejector.setInlierThreshold(0.1);
  // correspondence_rejector.setMaximumIterations(5000);
  // // correspondence_rejector.setRefineModel(true);
  // correspondence_rejector.setInputCorrespondences(new_correspondences);

  // boost::shared_ptr<pcl::Correspondences> cor_inliers_ptr (new pcl::Correspondences);
  // correspondence_rejector.getCorrespondences(*cor_inliers_ptr);

  // std::cout << "Correspondences remaining: " << cor_inliers_ptr->size() << std::endl;

  // if (cor_inliers_ptr->size() != 0 || cor_inliers_ptr->size() != new_correspondences->size()){
  //   total_cor += cor_inliers_ptr->size();
  // }
  // total_points += correspondences->size();

  // cout << "Total matches: " << total_cor << ", Total points: " << total_points << endl;
  cout << "Time: " <<  ros::WallTime::now()  << endl;

  // pcl::IterativeClosestPoint<pcl::PointXYZI, pcl::PointXYZI> icp;
  // icp.setInputSource(source_keypoints);
  // icp.setInputTarget(target_keypoints);
  // icp.setMaximumIterations(30);
  // icp.setMaxCorrespondenceDistance(5);
  // icp.setRANSACOutlierRejectionThreshold(0.1);
  // // icp.setTransformationEpsilon (1e-9);
  // pcl::PointCloud<pcl::PointXYZI> Final;
  // icp.align(Final);
  // Eigen::Matrix4f current_transformation;
  // current_transformation = icp.getFinalTransformation();
  // // cout << current_transformation << endl;
  // Eigen::Matrix3f rotation;
  // rotation << current_transformation(0,0), current_transformation(0,1), current_transformation(0,2),current_transformation(1,0), current_transformation(1,1), current_transformation(1,2),current_transformation(2,0), current_transformation(2,1), current_transformation(2,2);
  // total_rotation = total_rotation * rotation;
  // Eigen::Vector3f translation;
  // translation << current_transformation(0,3), current_transformation(1,3), current_transformation(2,3);
  // total_translation = total_translation + total_rotation*translation;
  // std::cout << total_translation(0) << ", " << total_translation(1) << ", " << total_translation(2) << ", " << acos(total_rotation(0,0)) << std::endl;
  // odom_file << total_translation(0) << ", " << total_translation(1) << ", " << total_translation(2) << ", " << acos(total_rotation(0,0)) << endl;

  target_keypoints = model_keypoints;
  target_cloud = point_cloud_ptr;

  // pcl::PCLPointCloud2 pcl_pc;
  // pcl::toPCLPointCloud2(*model_keypoints, pcl_pc);

  // pub3.publish (pcl_pc);
}

double iss_gamma_21_ (0.975); 
double iss_gamma_32_ (0.975);
double iss_min_neighbors_ (4);
int iss_threads_ (4);

void iss(const pcl::PointCloud<pcl::PointXYZI>::Ptr& point_cloud_ptr){
    // if (counter2%2==1) {
    double model_resolution = computeCloudResolution(point_cloud_ptr);
    double iss_salient_radius_(6*model_resolution);
    double iss_non_max_radius_(4*model_resolution);
    double iss_normal_radius_(4*model_resolution);
    double iss_border_radius_(model_resolution);


    pcl::PointCloud<pcl::PointXYZI>::Ptr model_keypoints (new pcl::PointCloud<pcl::PointXYZI> ());
    pcl::search::KdTree<pcl::PointXYZI>::Ptr tree (new pcl::search::KdTree<pcl::PointXYZI> ());
    pcl::search::KdTree<pcl::PointXYZI>::Ptr tree2 (new pcl::search::KdTree<pcl::PointXYZI> ());

    pcl::NormalEstimationOMP<pcl::PointXYZI, pcl::Normal> ne;
    ne.setInputCloud (point_cloud_ptr);
    ne.setSearchMethod (tree);
    pcl::PointCloud<pcl::Normal>::Ptr cloud_normals (new pcl::PointCloud<pcl::Normal>);
    ne.setRadiusSearch (3);
    // ne.setKSearch (60);
    ne.compute (*cloud_normals);

    pcl::ISSKeypoint3D<pcl::PointXYZI, pcl::PointXYZI> iss_detector;
  // if (counter % 2 == 1){
    iss_detector.setSearchMethod (tree);
    iss_detector.setSalientRadius (iss_salient_radius_);
    iss_detector.setNonMaxRadius (iss_non_max_radius_);

    iss_detector.setNormalRadius (iss_normal_radius_);
    iss_detector.setBorderRadius (iss_border_radius_);

    iss_detector.setThreshold21 (iss_gamma_21_);
    iss_detector.setThreshold32 (iss_gamma_32_);
    iss_detector.setMinNeighbors (iss_min_neighbors_);
    iss_detector.setNumberOfThreads (iss_threads_);
    iss_detector.setInputCloud (point_cloud_ptr);
    iss_detector.setNormals (cloud_normals);
    iss_detector.compute (*model_keypoints);

    // pcl::HarrisKeypoint3D <pcl::PointXYZI, pcl::PointXYZI> detector;
    // // pcl::PointCloud<pcl::PointXYZI>::Ptr keypoints (new pcl::PointCloud<pcl::PointXYZI>);
    // detector.setNonMaxSupression (true);
    // detector.setInputCloud (point_cloud_ptr);
    // detector.setThreshold (1e-5);
    // detector.setRadius(1.5);
    // detector.setNormals(cloud_normals);
    // detector.setRefine(false);
    // detector.compute (*model_keypoints);

    // const float min_scale = 0.2;
    // const int n_octaves = 6;
    // const int n_scales_per_octave = 4;
    // const float min_contrast = 0.5;
    
    // // /* Estimate the sift interest points using z values from xyz as the Intensity variants */
    // pcl::SIFTKeypoint<pcl::PointXYZI, pcl::PointWithScale> sift;
    // pcl::PointCloud<pcl::PointWithScale> result;
    // // pcl::search::KdTree<pcl::PointXYZI>::Ptr tree(new pcl::search::KdTree<pcl::PointXYZI> ());
    // sift.setSearchMethod(tree);
    // sift.setScales(min_scale, n_octaves, n_scales_per_octave);
    // sift.setMinimumContrast(min_contrast);
    // sift.setInputCloud(point_cloud_ptr);
    // sift.compute(result);
    // copyPointCloud(result, *model_keypoints);

    // float angular_resolution = 0.5f;
    // float support_size = 0.1f;
    // pcl::RangeImage::CoordinateFrame coordinate_frame = pcl::RangeImage::CAMERA_FRAME;
    // bool setUnseenToMaxRange = true;
    // bool rotation_invariant = true;
    
    // pcl::PointCloud<pcl::PointXYZI>& point_cloud = *point_cloud_ptr;
    // Eigen::Affine3f scene_sensor_pose (Eigen::Affine3f::Identity ());
    // scene_sensor_pose = Eigen::Affine3f (Eigen::Translation3f (point_cloud.sensor_origin_[0],
    //                                                             point_cloud.sensor_origin_[1],
    //                                                             point_cloud.sensor_origin_[2])) *
    //                       Eigen::Affine3f (point_cloud.sensor_orientation_);
    // angular_resolution = pcl::deg2rad (angular_resolution);
    // float noise_level = 0.0;
    // float min_range = 0.0f;
    // int border_size = 1;
    // pcl::RangeImage::Ptr range_image_ptr (new pcl::RangeImage);
    // pcl::RangeImage& range_image = *range_image_ptr;   
    // range_image.createFromPointCloud (point_cloud, angular_resolution, pcl::deg2rad (360.0f), pcl::deg2rad (180.0f),
    //                                 scene_sensor_pose, coordinate_frame, noise_level, min_range, border_size);
    // if (setUnseenToMaxRange){
    //     range_image.setUnseenToMaxRange();
    // }   

    // pcl::RangeImageBorderExtractor range_image_border_extractor;
    // pcl::NarfKeypoint narf_keypoint_detector;
    // narf_keypoint_detector.setRangeImageBorderExtractor (&range_image_border_extractor);
    // narf_keypoint_detector.setRangeImage (&range_image);
    // narf_keypoint_detector.getParameters ().support_size = support_size;
    
    // pcl::PointCloud<int> keypoint_indices;
    // narf_keypoint_detector.compute (keypoint_indices);

    // pcl::PointCloud<pcl::PointXYZI>::Ptr keypoints_ptr (new pcl::PointCloud<pcl::PointXYZI>);
    // pcl::PointCloud<pcl::PointXYZI>& keypoints = *model_keypoints;
    // keypoints.points.resize (keypoint_indices.points.size ());
    // for (size_t i=0; i<keypoint_indices.points.size (); ++i)
    //     keypoints.points[i].getVector3fMap () = range_image.points[keypoint_indices.points[i]].getVector3fMap ();

    source_keypoints = model_keypoints;
    source_cloud = point_cloud_ptr;
    // std::cout << "No of ISS points in the result are " << model_keypoints->points.size () << " and total points are " << iss_points << std::endl;

    model_keypoints->header.frame_id = point_cloud_ptr->header.frame_id;
    model_keypoints->header.stamp = point_cloud_ptr->header.stamp;

    pcl::PCLPointCloud2 pcl_pc;
    pcl::toPCLPointCloud2(*model_keypoints, pcl_pc);

    pub4.publish (pcl_pc);

    // Print timestamp?
    // std::cout << point_cloud_ptr->header.stamp << std::endl;

    // iss_points += model_keypoints->points.size();




    /* SHOT estimation part */

    pcl::SHOTEstimationOMP<pcl::PointXYZI, pcl::Normal, pcl::SHOT352> shot;
    shot.setInputCloud (model_keypoints);
    shot.setInputNormals (cloud_normals);
    shot.setSearchMethod (tree);
    shot.setSearchSurface (point_cloud_ptr);
    pcl::PointCloud<pcl::SHOT352>::Ptr shotFeatures (new pcl::PointCloud<pcl::SHOT352> ());
    // shot.setRadiusSearch (1.75);
    shot.setRadiusSearch (4);
    // shot.setKSearch(60);
    shot.compute (*shotFeatures);
    // std::cout << shotFeatures->size () << std::endl;

    for (size_t i = 0; i < shotFeatures->size (); ++i)
    {
      if (std::isnan(shotFeatures->points[i].descriptor[0])){
        for (size_t j = 0; j<352; ++j){
          shotFeatures->points[i].descriptor[j]=0;
        }
      }
    } 
    // std::cout << shotFeatures->size () << std::endl;

    source_cloud_keypoints = shotFeatures;

    boost::shared_ptr<pcl::Correspondences> correspondences (new pcl::Correspondences);
    pcl::registration::CorrespondenceEstimation<pcl::SHOT352, pcl::SHOT352> corr_est;
    corr_est.setInputSource (source_cloud_keypoints);
    corr_est.setInputTarget (target_cloud_keypoints);
    corr_est.determineReciprocalCorrespondences (*correspondences, 0.8);
    // corr_est.determineCorrespondences (*correspondences, 0.7);

    // std::cout << "Found " << correspondences->size() << " number of correspondences" << std::endl;


    /* FPFH estimation part */

    // pcl::FPFHEstimationOMP<pcl::PointXYZI, pcl::Normal, pcl::FPFHSignature33> fpfh;
    // fpfh.setInputCloud (model_keypoints);
    // fpfh.setInputNormals (cloud_normals);
    // fpfh.setSearchMethod (tree);
    // fpfh.setSearchSurface (point_cloud_ptr);
    // pcl::PointCloud<pcl::FPFHSignature33>::Ptr fpfhs (new pcl::PointCloud<pcl::FPFHSignature33> ());
    // fpfh.setRadiusSearch (5.0);
    // fpfh.compute (*fpfhs);
    // // std::cout << "Number of fpfh: " << fpfhs->points.size() << std::endl;

    // source_cloud_keypoints = fpfhs;

    // boost::shared_ptr<pcl::Correspondences> correspondences (new pcl::Correspondences);
    // pcl::registration::CorrespondenceEstimation<pcl::FPFHSignature33, pcl::FPFHSignature33> corr_est;
    // corr_est.setInputSource (source_cloud_keypoints);
    // corr_est.setInputTarget (target_cloud_keypoints);
    // corr_est.determineCorrespondences (*correspondences);

    // std::cout << "Found " << correspondences->size() << " number of correspondences" << std::endl;


    /* 3DSC estimation part*/

    // std::cout << point_cloud_ptr->header.stamp << std::endl;

    // pcl::ShapeContext3DEstimation<pcl::PointXYZI, pcl::Normal, pcl::ShapeContext1980> shape_context;

    // // Provide the point cloud
    // shape_context.setInputCloud (source_keypoints);
    // // Provide normals
    // shape_context.setInputNormals (cloud_normals);
    // shape_context.setSearchSurface (source_cloud);
    // // Use the same KdTree from the normal estimation
    // shape_context.setSearchMethod (tree);
    // pcl::PointCloud<pcl::ShapeContext1980>::Ptr shape_context_features(new pcl::PointCloud<pcl::ShapeContext1980>());
    // // The minimal radius is generally set to approx. 1/10 of the search radius, while the pt. density radius is generally set to 1/5
    // shape_context.setRadiusSearch (5);
    // shape_context.setPointDensityRadius (1.0);
    // shape_context.setMinimalRadius (0.5);
    // shape_context.compute (*shape_context_features);
    // for (size_t i = 0; i < shape_context_features->size (); ++i)
    // {
    //   if (std::isnan(shape_context_features->points[i].descriptor[0])){
    //     for (size_t j = 0; j<352; ++j){
    //       shape_context_features->points[i].descriptor[j]=0;
    //     }
    //   }
    // } 

    // source_cloud_keypoints = shape_context_features;

    // boost::shared_ptr<pcl::Correspondences> correspondences (new pcl::Correspondences);
    // pcl::registration::CorrespondenceEstimation<pcl::ShapeContext1980, pcl::ShapeContext1980> corr_est;
    // corr_est.setInputSource (source_cloud_keypoints);
    // corr_est.setInputTarget (target_cloud_keypoints);
    // corr_est.determineCorrespondences (*correspondences);

    /* PFH estimation */
    // pcl::PFHEstimation<pcl::PointXYZI, pcl::Normal, pcl::PFHSignature125> pfh;
    // pfh.setInputCloud (model_keypoints);
    // pfh.setInputNormals (cloud_normals);
    // pfh.setSearchMethod (tree2);
    // pfh.setSearchSurface (point_cloud_ptr);
    // pcl::PointCloud<pcl::PFHSignature125>::Ptr pfhs (new pcl::PointCloud<pcl::PFHSignature125> ());
    // pfh.setRadiusSearch (5);
    // pfh.compute (*pfhs);

    // source_cloud_keypoints = pfhs;

    // boost::shared_ptr<pcl::Correspondences> correspondences (new pcl::Correspondences);
    // pcl::registration::CorrespondenceEstimation<pcl::PFHSignature125, pcl::PFHSignature125> corr_est;
    // corr_est.setInputSource (source_cloud_keypoints);
    // corr_est.setInputTarget (target_cloud_keypoints);
    // corr_est.determineCorrespondences (*correspondences);
  //   std::cout << "Found " << correspondences->size() << " number of correspondences" << std::endl;

    // NO DESCRIPTOR
    // boost::shared_ptr<pcl::Correspondences> correspondences (new pcl::Correspondences);
    // pcl::registration::CorrespondenceEstimation<pcl::PointXYZI, pcl::PointXYZI> corr_est;
    // corr_est.setInputSource (source_keypoints);
    // corr_est.setInputTarget (target_keypoints);
    // corr_est.determineCorrespondences (*correspondences);

    boost::shared_ptr<pcl::Correspondences> new_correspondences (new pcl::Correspondences);
    pcl::registration::CorrespondenceRejectorDistance rej;
    rej.setInputSource<pcl::PointXYZI> (source_keypoints);
    rej.setInputTarget<pcl::PointXYZI> (target_keypoints);
    rej.setMaximumDistance (10);    // 7m
    rej.setInputCorrespondences (correspondences);
    rej.getCorrespondences (*new_correspondences);

    // std::cout << "Found " << new_correspondences->size() << " number of new correspondences" << std::endl;

    // std::cout << "Size of first image: " << source_cloud->size() << " Size of second image: " << target_cloud->size() << std::endl;

    pcl::registration::CorrespondenceRejectorSampleConsensus<pcl::PointXYZI> correspondence_rejector;
    correspondence_rejector.setInputSource(source_keypoints);
    correspondence_rejector.setInputTarget(target_keypoints);
    // correspondence_rejector.setInlierThreshold(0.2);
    correspondence_rejector.setInlierThreshold(0.2);
    correspondence_rejector.setMaximumIterations(800);
    correspondence_rejector.setRefineModel(true);
    correspondence_rejector.setInputCorrespondences(new_correspondences);

    boost::shared_ptr<pcl::Correspondences> cor_inliers_ptr (new pcl::Correspondences);
    correspondence_rejector.getCorrespondences(*cor_inliers_ptr);

    // std::cout << "Correspondences remaining: " << cor_inliers_ptr->size() << std::endl;

    Eigen::Matrix4f transformation; 
    transformation = correspondence_rejector.getBestTransformation();

    Eigen::Matrix3f current_rotation;
    current_rotation << 1, 0, 0, 0, 1, 0, 0, 0, 1;
    Eigen::Vector3f current_translation;
    current_translation << 0, 0, 0;

    if (counter != 0){
      if (cor_inliers_ptr->size() == 0 || cor_inliers_ptr->size() == new_correspondences->size() || abs(transformation(0,3))>0.5 || abs(transformation(1,3))>0.5 || abs(transformation(2,3))>1 || transformation(0,0)<0.99){
      // if (true){
        Eigen::Matrix4f guess; 
        guess << 1, 0, 0, 0.2, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1;
        pcl::IterativeClosestPoint<pcl::PointXYZI, pcl::PointXYZI> icp;
        // icp.setInputSource(source_keypoints);
        // icp.setInputTarget(target_keypoints);
        // icp.setMaximumIterations(300);
        // icp.setMaxCorrespondenceDistance(10);
        // icp.setRANSACOutlierRejectionThreshold(0.15);
        icp.setInputSource(source_cloud);
        icp.setInputTarget(target_cloud);
        icp.setMaximumIterations(50);
        icp.setMaxCorrespondenceDistance(10);
        icp.setRANSACOutlierRejectionThreshold(0.05);
        icp.setTransformationEpsilon (1e-9);
        pcl::PointCloud<pcl::PointXYZI> Final;
        icp.align(Final);
        Eigen::Matrix4f current_transformation;
        current_transformation = icp.getFinalTransformation();
        Eigen::Matrix3f rotation;
        rotation << current_transformation(0,0), current_transformation(0,1), current_transformation(0,2),current_transformation(1,0), current_transformation(1,1), current_transformation(1,2),current_transformation(2,0), current_transformation(2,1), current_transformation(2,2);
        current_rotation = rotation;
        total_rotation = total_rotation * rotation;
        since_last_rotation = since_last_rotation * rotation; 
        Eigen::Vector3f translation;
        translation << current_transformation(0,3), current_transformation(1,3), current_transformation(2,3);
        current_translation = translation;
        total_translation = total_translation + total_rotation*translation;
        since_last_translation = since_last_translation + since_last_rotation*translation;
        // slam_counter = 2;
        // std::cout << "Slam counter: " << slam_counter << std::endl;
        // std::cout << since_last_rotation << std::endl;
        since_last_transformation = since_last_transformation * current_transformation;
        // std::cout << since_last_translation << std::endl;
        distance_since_last += sqrt(pow(current_transformation(0,3),2) + pow(current_transformation(1,3),2) + pow(current_transformation(2,3), 2));
        // std::cout << "has converged:" << icp.hasConverged() << " score: " <<
        // icp.getFitnessScore() << std::endl;
        // std::cout << icp.getFinalTransformation() << std::endl;
        // std::cout << "ICP: " << std::endl;
        // total_transformation = total_transformation * icp.getFinalTransformation();
        std::cout << ros::WallTime::now() << ", " << total_translation(0) << ", " << total_translation(1) << ", " << total_translation(2) << ", " << acos(total_rotation(0,0)) << ", 1" << std::endl;
      } else {
        pcl::IterativeClosestPoint<pcl::PointXYZI, pcl::PointXYZI> icp2;
        // icp2.setInputSource(source_cloud);
        // icp2.setInputTarget(target_cloud);
        // icp2.setMaximumIterations(1);
        // icp2.setMaxCorrespondenceDistance(3);
        // // icp2.setRANSACOutlierRejectionThreshold(0.01);
        // // icp2.setTransformationEpsilon (1e-9);
        // pcl::PointCloud<pcl::PointXYZI> Final2;
        // icp2.align(Final2, transformation);
        // total_transformation = total_transformation * icp2.getFinalTransformation();
        Eigen::Matrix4f current_transformation;
        // current_transformation = icp2.getFinalTransformation();
        current_transformation = transformation;
        // cout << current_transformation << endl;
        Eigen::Matrix3f rotation;
        rotation << current_transformation(0,0), current_transformation(0,1), current_transformation(0,2),current_transformation(1,0), current_transformation(1,1), current_transformation(1,2),current_transformation(2,0), current_transformation(2,1), current_transformation(2,2);
        current_rotation = rotation;
        total_rotation = total_rotation * rotation; 
        since_last_rotation = since_last_rotation * rotation; 
        Eigen::Vector3f translation;
        translation << current_transformation(0,3), current_transformation(1,3), current_transformation(2,3);
        current_translation = translation;
        total_translation = total_translation + total_rotation*translation;
        since_last_translation = since_last_translation + since_last_rotation*translation;
        since_last_transformation = since_last_transformation * current_transformation;
        // std::cout << current_transformation << std::endl;
        distance_since_last += sqrt(pow(current_transformation(0,3),2) + pow(current_transformation(1,3),2) + pow(current_transformation(2,3), 2));
        // std::cout << "Slam counter: " << slam_counter << std::endl;
        // std::cout << since_last_rotation << std::endl;
        // std::cout << since_last_translation << std::endl;
        std::cout << ros::WallTime::now() << ", " << total_translation(0) << ", " << total_translation(1) << ", " << total_translation(2) << ", " << acos(total_rotation(0,0)) << ", 2" << std::endl;
      }
      // std::cout << "Total translation: \n" << total_translation << std::endl;
      // std::cout << "Total rotation: \n" << total_rotation << std::endl;
    }

    if (slam_counter % 4 == 1){
      pcl::PointCloud<pcl::SHOT352>::Ptr feat_cor_ (new pcl::PointCloud<pcl::SHOT352> ());
      pcl::PointCloud<pcl::PointXYZI>::Ptr source_cor_ (new pcl::PointCloud<pcl::PointXYZI> ());
      
      source_cor_->resize (cor_inliers_ptr->size ()); 
      feat_cor_->resize (cor_inliers_ptr->size ());
      
      for (size_t i = 0; i < cor_inliers_ptr->size (); ++i)
      {
          source_cor_->points[i] = source_keypoints->points[ (*cor_inliers_ptr)[i].index_query];
          feat_cor_->points[i] = source_cloud_keypoints->points[ (*cor_inliers_ptr)[i].index_query];
      }

      pcl::transformPointCloud (*source_cor_, *trans_keypoints, since_last_transformation);
      *loop_keypoints = *loop_keypoints + *trans_keypoints;
      *loop_cloud_keypoints = *loop_cloud_keypoints + *feat_cor_;
    }


    if ((slam_counter%12==2)/* || distance_since_last > 3*/){
    if (send_message) {
      send_message = false;
      for (size_t i = 0; i < loop->size (); ++i)
      {
        std::ostringstream ss;
        ss << loop2->points[i].data_c[1];
        point_msg.header.frame_id = ss.str();
        point.x = loop->points[i].x;
        point.y = loop->points[i].y;
        point.z = loop->points[i].z;
        // point.x = 0;
        // point.y = 0;
        // point.z = 0;

        std::cout << loop2->points[i].data_c[1] << " Map: " << "x: " << loop2->points[i].x << ", y: " << loop2->points[i].y << ", z: " << loop2->points[i].z << std::endl;
        std::cout << "Source: " << "x: " << loop->points[i].x << ", y: " << loop->points[i].y << ", z: " << loop->points[i].z << std::endl;

        point_msg.point = point;

        pub8.publish(point_msg);
        usleep(30);
      }

      // cout << "Debug mode 2" << endl;

      // std::cout << "Some shit " << std::endl;

      for (size_t i = 0; i< source_cor->size(); ++i)
      {
        std::ostringstream ss;
        ss << source_cor->points[i].data_c[1];
        point_msg.header.frame_id = ss.str();
        point.x = source_cor->points[i].x;
        point.y = source_cor->points[i].y;
        point.z = source_cor->points[i].z;

        // std::cout << source_cor->points[i].data_c[1] << " Map: " << "x: " << source_cor->points[i].x << ", y: " << source_cor->points[i].y << ", z: " << source_cor->points[i].z << std::endl;

        point_msg.point = point;
        pub8.publish(point_msg);
        usleep(30);
      }

      for (size_t i = 0; i < loop->size (); ++i)
      {
          map_translation << loop->points[i].x, loop->points[i].y, loop->points[i].z;
          // nav_trans << north, east, 0;
          // nav_rot << cos(theta), -sin(theta), 0, sin(theta), cos(theta), 0, 0, 0, 1;
          // map_total_translation = nav_trans + nav_rot * map_translation;
          map_total_translation = total_translation + total_rotation*map_translation;

          // cout << "After transofmration: " << map_total_translation(0) << ", " << map_total_translation(1) << ", " << map_total_translation(2) << endl;

          loop->points[i].x = map_total_translation(0);
          loop->points[i].y = map_total_translation(1);
          loop->points[i].z = map_total_translation(2);
      }

      // std::cout << "Some more shit " << std::endl;
      *loop_closure_map = *loop_closure_map + *loop2;
      *loop_closure_map2 = *loop_closure_map2 + *loop;

      pcl::PCLPointCloud2 pcl_pc_2;
      pcl::toPCLPointCloud2(*loop_closure_map, pcl_pc_2);
      pub10.publish(pcl_pc_2);

      pcl::PCLPointCloud2 pcl_pc_3;
      pcl::toPCLPointCloud2(*loop_closure_map2, pcl_pc_3);
      pub11.publish(pcl_pc_3);
    } 
      geometry_msgs::PoseStamped pose_msg;
      geometry_msgs::Pose pose; 
      std::ostringstream ss;
      ss << counter;
      pose_msg.header.frame_id = ss.str();
      pose_msg.header.stamp = ros::Time::now();//point_cloud_ptr->header.stamp;

      pcl::transformPointCloud (*loop_keypoints, *loop_keypoints, since_last_transformation.inverse());

      // cout << "Total translation: \n" << total_translation << endl;
      // cout << "Total rotation: \n" << total_rotation << endl;
      
      pose.position.x = since_last_translation(0);
      pose.position.y = since_last_translation(1);
      pose.position.z = since_last_translation(2);
      // pose.position.z = 0;
      // pose.orientation.x = 0.0;
      // pose.orientation.y = 0.0;
      // pose.orientation.z = 0.0;
      // pose.orientation.w = 1.0;

      // since_last_rotation << since_last_rotation(0,0), since_last_rotation(0,1), 0, since_last_rotation(1,0), since_last_rotation(1,1), 0, 0, 0, 1;

      // std::cout << "quat" << std::endl;

      // since_last_rotation(0,1) = - since_last_rotation(0,1);
      // since_last_rotation(1,0) = - since_last_rotation(1,0);

      float trace = since_last_rotation(0,0) + since_last_rotation(1,1) + since_last_rotation(2,2); 
      if( trace > 0 ) {
        float s = 0.5f / sqrtf(trace+ 1.0f);
        pose.orientation.w = 0.25f / s;
        pose.orientation.x = ( since_last_rotation(2,1) - since_last_rotation(1,2) ) * s;
        pose.orientation.y = ( since_last_rotation(0,2) - since_last_rotation(2,0) ) * s;
        pose.orientation.z = ( since_last_rotation(1,0) - since_last_rotation(0,1) ) * s;
      } else {
        if ( since_last_rotation(0,0) > since_last_rotation(1,1) && since_last_rotation(0,0) > since_last_rotation(2,2) ) {
          float s = 2.0f * sqrtf( 1.0f + since_last_rotation(0,0) - since_last_rotation(1,1) - since_last_rotation(2,2));
          pose.orientation.w = (since_last_rotation(2,1) - since_last_rotation(1,2) ) / s;
          pose.orientation.x = 0.25f * s;
          pose.orientation.y = (since_last_rotation(0,1) + since_last_rotation(1,0) ) / s;
          pose.orientation.z = (since_last_rotation(0,2) + since_last_rotation(2,0) ) / s;
        } else if (since_last_rotation(1,1) > since_last_rotation(2,2)) {
          float s = 2.0f * sqrtf( 1.0f + since_last_rotation(1,1) - since_last_rotation(0,0) - since_last_rotation(2,2));
          pose.orientation.w = (since_last_rotation(0,2) - since_last_rotation(2,0) ) / s;
          pose.orientation.x = (since_last_rotation(0,1) + since_last_rotation(1,0) ) / s;
          pose.orientation.y = 0.25f * s;
          pose.orientation.z = (since_last_rotation(1,2) + since_last_rotation(2,1) ) / s;
        } else {
          float s = 2.0f * sqrtf( 1.0f + since_last_rotation(2,2) - since_last_rotation(0,0) - since_last_rotation(1,1) );
          pose.orientation.w = (since_last_rotation(1,0) - since_last_rotation(0,1) ) / s;
          pose.orientation.x = (since_last_rotation(0,2) + since_last_rotation(2,0) ) / s;
          pose.orientation.y = (since_last_rotation(1,2) + since_last_rotation(2,1) ) / s;
          pose.orientation.z = 0.25f * s;
        }
      }
      pose_msg.pose = pose;

      pub7.publish(pose_msg);
      counter++;

      // usleep(10000);

      since_last_rotation << 1, 0, 0, 0, 1, 0, 0, 0, 1;
      since_last_translation << 0, 0, 0;
      since_last_transformation << 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1;
      
      pcl::PointCloud<pcl::SHOT352>::Ptr feat_cor (new pcl::PointCloud<pcl::SHOT352> ());
      // pcl::PointCloud<pcl::FPFHSignature33>::Ptr feat_cor (new pcl::PointCloud<pcl::FPFHSignature33> ());
      // pcl::PointCloud<pcl::ShapeContext1980>::Ptr feat_cor (new pcl::PointCloud<pcl::ShapeContext1980>());
      // pcl::PointCloud<pcl::PFHSignature125>::Ptr feat_cor (new pcl::PointCloud<pcl::PFHSignature125>());
      source_cor->resize (cor_inliers_ptr->size ()); 
      feat_cor->resize (cor_inliers_ptr->size ());

      
      bool zero_test = false;
      // distance_since_last = 0;
      
      int iter = 0;


      for (size_t i = 0; i < cor_inliers_ptr->size (); ++i)
      {
        // for (int j = 0; j < 33; ++j){
        //   if (source_cloud_keypoints->points[(*cor_inliers_ptr)[i].index_query].histogram[j]>99){
        //     zero_test = true;
        //   }
        // }
        // cout << "Correspondence distance: " << (*cor_inliers_ptr)[i].distance << endl;
        if ( /*(cor_inliers_ptr->size() > 8 &&*/  (*cor_inliers_ptr)[i].distance > 0.06 ||/*  i % 7 != 0 ||*/ std::isnan(source_cloud_keypoints->points[(*cor_inliers_ptr)[i].index_query].rf[0]) || source_cloud_keypoints->points[(*cor_inliers_ptr)[i].index_query].rf[0]==0 /*|| abs(source_keypoints->points[(*cor_inliers_ptr)[i].index_query].z)>10*/ || abs(source_keypoints->points[(*cor_inliers_ptr)[i].index_query].x)>30 || abs(source_keypoints->points[(*cor_inliers_ptr)[i].index_query].y)>30){
          source_cor->points.erase(source_cor->begin()+iter);
          feat_cor->points.erase(feat_cor->begin()+iter);
        } else {
          source_cor->points[iter] = source_keypoints->points[ (*cor_inliers_ptr)[i].index_query];
          feat_cor->points[iter] = source_cloud_keypoints->points[ (*cor_inliers_ptr)[i].index_query];
          iter++;
          // std::cout << "True: " << (*cor_inliers_ptr)[i].index_query << std::endl;
          // std::cout << "False: " << source_keypoints->points[ (*cor_inliers_ptr)[i].index_query].data_c[1] << "\n" << source_cloud_keypoints->points[ (*cor_inliers_ptr)[i].index_query] << std::endl;
        }
      }

      // point_msg.header.frame_id = point_cloud_ptr->header.frame_id;
      point_msg.header.stamp = ros::Time::now();//point_cloud_ptr->header.stamp;
      pcl::PointCloud<pcl::PointXYZI>::Ptr map_loop (new pcl::PointCloud<pcl::PointXYZI> ());
      map_loop->resize (source_cor->size ()); 

      for (size_t i = 0; i < source_cor->size (); ++i)
      {
          map_translation << source_cor->points[i].x, source_cor->points[i].y, source_cor->points[i].z;
          // nav_trans << north, east, 0;
          // nav_rot << cos(theta), -sin(theta), 0, sin(theta), cos(theta), 0, 0, 0, 1;
          nav_trans = total_translation;
          nav_rot = total_rotation;

          // map_total_translation = total_translation + total_rotation*map_translation;
          map_total_translation = nav_trans + nav_rot * map_translation;

          map_loop->points[i].x = map_total_translation(0);
          map_loop->points[i].y = map_total_translation(1);
          map_loop->points[i].z = map_total_translation(2);
          // cout << "Translation: " << total_translation << ", rotation: " << total_rotation << endl;
          // cout << "Map translation\n" << map_translation << endl;
          // cout << "After transformation: " << counter2 << " " <<  map_total_translation(0) << " " << map_total_translation(1) << " " << map_total_translation(2) << endl;
 
          map_loop->points[i].data_c[1] = counter2;
          source_cor->points[i].data_c[1] = counter2;
          counter2++;
          // std::cout << "Counter: " << counter2 << std::endl;
      }


      // pcl::PointCloud<pcl::PointXYZI>::Ptr test_map (new pcl::PointCloud<pcl::PointXYZI> ());
      // pcl::PointCloud<pcl::SHOT352>::Ptr test_feat (new pcl::PointCloud<pcl::SHOT352> ());

      // if (map->size() > 500){
      //   test_map = map;
      //   test_map->resize(map->size()-500);
      //   test_feat = feature_map;
      //   test_feat->resize(feature_map->size()-500);
      // }

      pcl::PointIndices::Ptr inliers(new pcl::PointIndices());
      pcl::ExtractIndices<pcl::SHOT352> extract;
      std::vector<int> indices;

      pcl::ConditionAnd<pcl::PointXYZI>::Ptr range_cond (new pcl::ConditionAnd<pcl::PointXYZI> ());
      range_cond->addComparison(pcl::FieldComparison<pcl::PointXYZI>::ConstPtr (new
      pcl::FieldComparison<pcl::PointXYZI> ("x", pcl::ComparisonOps::LT, total_translation(0)+40.0)));
      range_cond->addComparison(pcl::FieldComparison<pcl::PointXYZI>::ConstPtr (new
      pcl::FieldComparison<pcl::PointXYZI> ("x", pcl::ComparisonOps::GT, total_translation(0)-40.0)));
      range_cond->addComparison(pcl::FieldComparison<pcl::PointXYZI>::ConstPtr (new
      pcl::FieldComparison<pcl::PointXYZI> ("y", pcl::ComparisonOps::LT, total_translation(1)+40.0)));
      range_cond->addComparison(pcl::FieldComparison<pcl::PointXYZI>::ConstPtr (new
      pcl::FieldComparison<pcl::PointXYZI> ("y", pcl::ComparisonOps::GT, total_translation(1)-40.0)));
      // build the filter
      pcl::ConditionalRemoval<pcl::PointXYZI> condrem(true);
      condrem.setCondition(range_cond);
      condrem.setInputCloud(map);
      // apply filter
      condrem.filter(*filtered_loop_keypoints);
      // pcl::IndicesConstPtr inliers2 = condrem.getRemovedIndices();
      condrem.getRemovedIndices(*inliers);

      // pcl::KdTreeFLANN<pcl::PointXYZI> kdtree;
      // kdtree.setInputCloud(filtered_loop_keypoints)
      // kdtree.nearestKSearch(*map)
      // // kdtree.nearestKSearch(*map, 1, 1, *indices)
      // inliers = kdtree.getIndices()

      extract.setInputCloud(feature_map);
      extract.setIndices(inliers);
      extract.setNegative(true);
      extract.filter(*filtered_loop_cloud_keypoints);

      boost::shared_ptr<pcl::Correspondences> cor_inliers_ptr_ (new pcl::Correspondences);
      boost::shared_ptr<pcl::Correspondences> new_correspondences_2 (new pcl::Correspondences);
      // pcl::registration::CorrespondenceEstimation<pcl::ShapeContext1980, pcl::ShapeContext1980> corr_est_;
      // pcl::registration::CorrespondenceEstimation<pcl::FPFHSignature33, pcl::FPFHSignature33> corr_est_;
      pcl::registration::CorrespondenceEstimation<pcl::SHOT352, pcl::SHOT352> corr_est_;
      // pcl::registration::CorrespondenceEstimation<pcl::PFHSignature125, pcl::PFHSignature125> corr_est_;
      corr_est_.setInputSource (loop_cloud_keypoints);
      // corr_est_.setInputTarget (feat_cor);
      corr_est_.setInputTarget (filtered_loop_cloud_keypoints);
      // corr_est_.determineCorrespondences (*new_correspondences_, 15);
      // corr_est_.determineCorrespondences (*new_correspondences_2, 0.2);
      // corr_est_.determineCorrespondences (*new_correspondences_, 0.4);
      corr_est_.determineReciprocalCorrespondences (*new_correspondences_2, 0.35);

      // boost::shared_ptr<pcl::Correspondences> new_correspondences_ (new pcl::Correspondences);
      // pcl::registration::CorrespondenceEstimation<pcl::PointXYZI, pcl::PointXYZI> corr_est;
      // corr_est.setInputSource (map);
      // corr_est.setInputTarget (map_loop);
      // corr_est.determineCorrespondences (*new_correspondences_);

      cout << "Found " << new_correspondences_2->size() << " number of correspondences" << endl;

      // boost::shared_ptr<pcl::Correspondences> new_correspondences_2 (new pcl::Correspondences);
      // pcl::registration::CorrespondenceRejectorDistance rej;
      // rej.setInputSource<pcl::PointXYZI> (map);
      // // rej.setInputTarget<pcl::PointXYZI> (map_loop);
      // rej.setInputTarget<pcl::PointXYZI> (target_keypoints);
      // rej.setMaximumDistance (10);    // 7m
      // rej.setInputCorrespondences (new_correspondences_);
      // rej.getCorrespondences (*new_correspondences_2);

      // std::cout << "Found " << new_correspondences_2->size() << " number of new correspondences" << std::endl;

      // std::cout << "Size of first image: " << source_cloud->size() << " Size of second image: " << target_cloud->size() << std::endl;

      pcl::registration::CorrespondenceRejectorSampleConsensus<pcl::PointXYZI> correspondence_rejector;
      correspondence_rejector.setInputSource(loop_keypoints);
      // correspondence_rejector.setInputTarget(map_loop);
      correspondence_rejector.setInputTarget(filtered_loop_keypoints);
      correspondence_rejector.setInlierThreshold(0.1);
      correspondence_rejector.setMaximumIterations(1000);
      correspondence_rejector.setInputCorrespondences(new_correspondences_2);
      correspondence_rejector.getCorrespondences(*cor_inliers_ptr_);


      // std::cout << "Found " << new_correspondences_2->size() << " number of new correspondences" << std::endl;
      
      if (cor_inliers_ptr_->size () == new_correspondences_2->size ()){
        loop->resize (0); 
        loop2->resize (0);
        // cout << "This is probably the reason" << endl;
      } else {
        loop->resize (cor_inliers_ptr_->size ()); 
        loop2->resize (cor_inliers_ptr_->size ()); 
      }

      int matches[cor_inliers_ptr_->size()];
      for (size_t i = 0; i < cor_inliers_ptr_->size (); ++i)
      {
        matches[i] = (*cor_inliers_ptr_)[i].index_match;
      }

      std::vector<int> matches_sorted (matches, matches + cor_inliers_ptr_->size());
      // std::sort(matches.begin(), matches.end(), greater<int>());
      std::sort(matches_sorted.begin(), matches_sorted.end());

      // for (int i = 0; i < cor_inliers_ptr_->size (); i++){
      //   cout << matches_sorted[i] << endl;
      // }

      // cout << "Correspondences: " << new_correspondences_2->size() << ", after RANSAC: " << cor_inliers_ptr_->size() << endl;
      
      int k=0;
      for (size_t i = 0; i < cor_inliers_ptr_->size (); ++i)
      {
        if (cor_inliers_ptr_->size () == new_correspondences_2->size ()){
          break;
        }
        k = cor_inliers_ptr_->size () - 1 - i;
        // cout << "Before" << endl;
        // cout << (*cor_inliers_ptr_)[k].index_match << endl;
        // cout << (*cor_inliers_ptr_)[k].index_query << endl;
        // loop->points[i] = source_cor->points[ (*cor_inliers_ptr_)[k].index_match];
        loop->points[i] = loop_keypoints->points[ (*cor_inliers_ptr_)[k].index_query];
        loop2->points[i] = filtered_loop_keypoints->points[ (*cor_inliers_ptr_)[k].index_match];
        // std::cout << "Matching feature: " << map->points[ (*cor_inliers_ptr_)[k].index_match].data_c[1] << ", distance: " << (*cor_inliers_ptr_)[k].distance << "\n" << feat_cor->points[ (*cor_inliers_ptr_)[i].index_match] << std::endl;
        // std::cout << "Matching point: " << target_keypoints->points[ (*cor_inliers_ptr_)[i].index_match] << std::endl;
        // source_cor->points.erase(source_cor->begin()+matches_sorted[k]);
        // feat_cor->points.erase(feat_cor->begin()+matches_sorted[k]);
        // map_loop->points.erase(map_loop->begin()+matches_sorted[k]);
      } 

      // cout << "Debug mode 1" << endl;

      // pcl::PointCloud<pcl::PointXYZI>::Ptr loop (new pcl::PointCloud<pcl::PointXYZI> ());
      // loop->resize (new_correspondences_->size ()); 
      // pcl::PointCloud<pcl::PointXYZI>::Ptr loop2 (new pcl::PointCloud<pcl::PointXYZI> ());
      // loop2->resize (new_correspondences_->size ()); 

      // int k=0;
      // for (size_t i = 0; i < new_correspondences_->size (); ++i)
      // {
      //   k = new_correspondences_->size () - 1 - i;
      //   loop->points[i] = source_cor->points[ (*new_correspondences_)[k].index_query];
      //   loop2->points[i] = map->points[ (*new_correspondences_)[k].index_match];
      //   // std::cout << "Matching feature: " << map->points[ (*new_correspondences_)[k].index_match].data_c[1] << ", distance: " << (*new_correspondences_)[k].distance << "\n" << feat_cor->points[ (*new_correspondences_)[i].index_query] << std::endl;
      //   // std::cout << "Matching point: " << source_cor->points[ (*new_correspondences_)[i].index_query] << std::endl;
      //   source_cor->points.erase(source_cor->begin()+(*new_correspondences_)[k].index_query);
      //   feat_cor->points.erase(feat_cor->begin()+(*new_correspondences_)[k].index_query);
      //   map_loop->points.erase(map_loop->begin()+(*new_correspondences_)[k].index_query);
      //   // source_cor->width--;
      // } 
      // geometry_msgs::PoseStamped pose_msg;
      // geometry_msgs::Pose pose; 
      // std::ostringstream ss;
      // ss << counter;
      // pose_msg.header.frame_id = ss.str();
      // pose_msg.header.stamp = ros::Time::now();//point_cloud_ptr->header.stamp;

      // // cout << "Total rotation: \n" << total_rotation << endl;
      
      // pose.position.x = since_last_translation(0);
      // pose.position.y = since_last_translation(1);
      // pose.position.z = since_last_translation(2);
      // // pose.position.z = 0;
      // // pose.orientation.x = 0.0;
      // // pose.orientation.y = 0.0;
      // // pose.orientation.z = 0.0;
      // // pose.orientation.w = 1.0;

      // // since_last_rotation << since_last_rotation(0,0), since_last_rotation(0,1), 0, since_last_rotation(1,0), since_last_rotation(1,1), 0, 0, 0, 1;

      // // std::cout << "quat" << std::endl;

      // // since_last_rotation(0,1) = - since_last_rotation(0,1);
      // // since_last_rotation(1,0) = - since_last_rotation(1,0);

      // float trace = since_last_rotation(0,0) + since_last_rotation(1,1) + since_last_rotation(2,2); 
      // if( trace > 0 ) {
      //   float s = 0.5f / sqrtf(trace+ 1.0f);
      //   pose.orientation.w = 0.25f / s;
      //   pose.orientation.x = ( since_last_rotation(2,1) - since_last_rotation(1,2) ) * s;
      //   pose.orientation.y = ( since_last_rotation(0,2) - since_last_rotation(2,0) ) * s;
      //   pose.orientation.z = ( since_last_rotation(1,0) - since_last_rotation(0,1) ) * s;
      // } else {
      //   if ( since_last_rotation(0,0) > since_last_rotation(1,1) && since_last_rotation(0,0) > since_last_rotation(2,2) ) {
      //     float s = 2.0f * sqrtf( 1.0f + since_last_rotation(0,0) - since_last_rotation(1,1) - since_last_rotation(2,2));
      //     pose.orientation.w = (since_last_rotation(2,1) - since_last_rotation(1,2) ) / s;
      //     pose.orientation.x = 0.25f * s;
      //     pose.orientation.y = (since_last_rotation(0,1) + since_last_rotation(1,0) ) / s;
      //     pose.orientation.z = (since_last_rotation(0,2) + since_last_rotation(2,0) ) / s;
      //   } else if (since_last_rotation(1,1) > since_last_rotation(2,2)) {
      //     float s = 2.0f * sqrtf( 1.0f + since_last_rotation(1,1) - since_last_rotation(0,0) - since_last_rotation(2,2));
      //     pose.orientation.w = (since_last_rotation(0,2) - since_last_rotation(2,0) ) / s;
      //     pose.orientation.x = (since_last_rotation(0,1) + since_last_rotation(1,0) ) / s;
      //     pose.orientation.y = 0.25f * s;
      //     pose.orientation.z = (since_last_rotation(1,2) + since_last_rotation(2,1) ) / s;
      //   } else {
      //     float s = 2.0f * sqrtf( 1.0f + since_last_rotation(2,2) - since_last_rotation(0,0) - since_last_rotation(1,1) );
      //     pose.orientation.w = (since_last_rotation(1,0) - since_last_rotation(0,1) ) / s;
      //     pose.orientation.x = (since_last_rotation(0,2) + since_last_rotation(2,0) ) / s;
      //     pose.orientation.y = (since_last_rotation(1,2) + since_last_rotation(2,1) ) / s;
      //     pose.orientation.z = 0.25f * s;
      //   }
      // }
      // pose_msg.pose = pose;

      // pub7.publish(pose_msg);
      // counter++;

      // usleep(200000);

      // since_last_rotation << 1, 0, 0, 0, 1, 0, 0, 0, 1;
      // since_last_translation << 0, 0, 0;
    
      // cout << "Debug mode 3" << endl;
        if (slam_counter % 60 == 2 || distance_since_last > 3){
            send_message = true;
            slam_counter = 3;
            distance_since_last = 0;
        }


      // *current_map = *current_map + *map_loop;
      // *current_feature_map = *current_feature_map + *feat_cor;

      // if (slam_counter % 25 == 0){ 
      if (send_message){
        *later_loop_keypoints = *later_loop_keypoints + *map_loop;
        *later_loop_cloud_keypoints = *later_loop_cloud_keypoints + *feat_cor;
        map_counter++;

      }

      if (map_counter % 5 == 1){
        *feature_map = *feature_map + *later_loop_cloud_keypoints;
        *map = *map + *later_loop_keypoints;
        later_loop_cloud_keypoints->resize(0);
        later_loop_keypoints->resize(0);
      }
      // map_counter++;

        // current_feature_map->resize(0);
        // current_map->resize(0);
        // cout << "Resized maps"
      // }
      // cout << "Map size: " << map->size() << endl;
      // if (map->size() != 0){
      //   pcl::io::savePCDFileASCII ("map.pcd", *map);
      // }
      // if (source_cor->size() != 0){
      //   pcl::io::savePCDFileASCII ("source_cor.pcd", *source_cor);
      // }

      // cout << "Feature map size: " << feature_map->size() << endl;

      map->header.frame_id = point_cloud_ptr->header.frame_id;
      map->header.stamp = point_cloud_ptr->header.stamp;

      filtered_loop_keypoints->header.frame_id = point_cloud_ptr->header.frame_id;
      filtered_loop_keypoints->header.stamp = point_cloud_ptr->header.stamp;

      loop->header.frame_id = point_cloud_ptr->header.frame_id;
      loop->header.stamp = point_cloud_ptr->header.stamp;

      loop_closure_map->header.frame_id = point_cloud_ptr->header.frame_id;
      loop_closure_map->header.stamp = point_cloud_ptr->header.stamp;

      loop_closure_map2->header.frame_id = point_cloud_ptr->header.frame_id;
      loop_closure_map2->header.stamp = point_cloud_ptr->header.stamp;

      pcl::PCLPointCloud2 pcl_pc_;
      pcl::toPCLPointCloud2(*filtered_loop_keypoints, pcl_pc_);
      pub9.publish(pcl_pc_);

      /*if (cor_inliers_ptr->size() == 0){
        slam_counter == 35;
      }*/
      loop_keypoints->resize(0);
      loop_cloud_keypoints->resize(0);

    }  

    slam_counter++;

    target_cloud_keypoints = shotFeatures;
    // target_cloud_keypoints = shape_context_features;
    // target_cloud_keypoints = fpfhs;
    // target_cloud_keypoints = pfhs;
    target_keypoints = model_keypoints;
    target_cloud = point_cloud_ptr;


    // total_distance += sqrt(pow(north - prev_north,2) + pow(east - prev_east,2));
    // prev_north = north;
    // prev_east = east;

    // cout << "Total distance: " << total_distance << endl;

    // pcl::visualization::PointCloudColorHandlerCustom<pcl::PointXYZI> white(target_keypoints, 255, 255, 255);
    // viewer->addPointCloud<pcl::PointXYZI> (target_keypoints, white, "source cloud2");
    // viewer->setPointCloudRenderingProperties (pcl::visualization::PCL_VISUALIZER_POINT_SIZE, 2, "source cloud2");

    // while (!viewer->wasStopped ())
    // {
    //   // viewer->spinOnce();
    // }

    // std::cout << "Almost there" << std::endl;

    // if (send_message){
    //   geometry_msgs::PoseStamped pose_msg;
    //   geometry_msgs::Pose pose; 
    //   std::ostringstream ss;
    //   ss << counter;
    //   pose_msg.header.frame_id = ss.str();
    //   pose_msg.header.stamp = ros::Time::now();//point_cloud_ptr->header.stamp;

    //   // cout << "Total rotation: \n" << total_rotation << endl;
      
    //   pose.position.x = since_last_translation(0);
    //   pose.position.y = since_last_translation(1);
    //   pose.position.z = since_last_translation(2);
    //   // pose.position.z = 0;
    //   // pose.orientation.x = 0.0;
    //   // pose.orientation.y = 0.0;
    //   // pose.orientation.z = 0.0;
    //   // pose.orientation.w = 1.0;

    //   // since_last_rotation << since_last_rotation(0,0), since_last_rotation(0,1), 0, since_last_rotation(1,0), since_last_rotation(1,1), 0, 0, 0, 1;

    //   // std::cout << "quat" << std::endl;

    //   // since_last_rotation(0,1) = - since_last_rotation(0,1);
    //   // since_last_rotation(1,0) = - since_last_rotation(1,0);

    //   float trace = since_last_rotation(0,0) + since_last_rotation(1,1) + since_last_rotation(2,2); 
    //   if( trace > 0 ) {
    //     float s = 0.5f / sqrtf(trace+ 1.0f);
    //     pose.orientation.w = 0.25f / s;
    //     pose.orientation.x = ( since_last_rotation(2,1) - since_last_rotation(1,2) ) * s;
    //     pose.orientation.y = ( since_last_rotation(0,2) - since_last_rotation(2,0) ) * s;
    //     pose.orientation.z = ( since_last_rotation(1,0) - since_last_rotation(0,1) ) * s;
    //   } else {
    //     if ( since_last_rotation(0,0) > since_last_rotation(1,1) && since_last_rotation(0,0) > since_last_rotation(2,2) ) {
    //       float s = 2.0f * sqrtf( 1.0f + since_last_rotation(0,0) - since_last_rotation(1,1) - since_last_rotation(2,2));
    //       pose.orientation.w = (since_last_rotation(2,1) - since_last_rotation(1,2) ) / s;
    //       pose.orientation.x = 0.25f * s;
    //       pose.orientation.y = (since_last_rotation(0,1) + since_last_rotation(1,0) ) / s;
    //       pose.orientation.z = (since_last_rotation(0,2) + since_last_rotation(2,0) ) / s;
    //     } else if (since_last_rotation(1,1) > since_last_rotation(2,2)) {
    //       float s = 2.0f * sqrtf( 1.0f + since_last_rotation(1,1) - since_last_rotation(0,0) - since_last_rotation(2,2));
    //       pose.orientation.w = (since_last_rotation(0,2) - since_last_rotation(2,0) ) / s;
    //       pose.orientation.x = (since_last_rotation(0,1) + since_last_rotation(1,0) ) / s;
    //       pose.orientation.y = 0.25f * s;
    //       pose.orientation.z = (since_last_rotation(1,2) + since_last_rotation(2,1) ) / s;
    //     } else {
    //       float s = 2.0f * sqrtf( 1.0f + since_last_rotation(2,2) - since_last_rotation(0,0) - since_last_rotation(1,1) );
    //       pose.orientation.w = (since_last_rotation(1,0) - since_last_rotation(0,1) ) / s;
    //       pose.orientation.x = (since_last_rotation(0,2) + since_last_rotation(2,0) ) / s;
    //       pose.orientation.y = (since_last_rotation(1,2) + since_last_rotation(2,1) ) / s;
    //       pose.orientation.z = 0.25f * s;
    //     }
    //   }
    //   pose_msg.pose = pose;

    //   pub7.publish(pose_msg);
    //   counter++;

    //   since_last_rotation << 1, 0, 0, 0, 1, 0, 0, 0, 1;
    //   since_last_translation << 0, 0, 0;

    //   send_message = false;
    // }

  // }
    if (nav_online){
      file << north << ", " << east << ", " << 0 << endl;
    }
    odom_file << point_cloud_ptr->header.stamp << ", " << total_translation(0) << ", " << total_translation(1) << ", " << total_translation(2) << ", " << acos(total_rotation(0,0)) << endl;

    // pcl::PCLPointCloud2 pcl_pc2;
    // pcl::toPCLPointCloud2(*map, pcl_pc2);

    // pub5.publish (pcl_pc2);

    // slam_counter++;
  // }
  // counter2++;


}

void harris(const pcl::PointCloud<pcl::PointXYZI>::Ptr& point_cloud_ptr){
  pcl::PointCloud<pcl::PointXYZI>::Ptr model_keypoints (new pcl::PointCloud<pcl::PointXYZI> ());

  pcl::NormalEstimationOMP<pcl::PointXYZI, pcl::Normal> ne;
  ne.setInputCloud (point_cloud_ptr);
  pcl::search::KdTree<pcl::PointXYZI>::Ptr tree (new pcl::search::KdTree<pcl::PointXYZI> ());
  ne.setSearchMethod (tree);
  pcl::PointCloud<pcl::Normal>::Ptr cloud_normals (new pcl::PointCloud<pcl::Normal>);
  ne.setRadiusSearch (1);
  ne.compute (*cloud_normals);

  pcl::HarrisKeypoint3D <pcl::PointXYZI, pcl::PointXYZI> detector;
  pcl::PointCloud<pcl::PointXYZI>::Ptr keypoints (new pcl::PointCloud<pcl::PointXYZI>);
  detector.setNonMaxSupression (true);
  detector.setInputCloud (point_cloud_ptr);
  detector.setThreshold (1e-5);
  detector.setRadius(1.5);
  detector.setNormals(cloud_normals);
  detector.setRefine(false);
  detector.compute (*keypoints);

  cout << "Time: " <<  ros::WallTime::now()  << endl;

  // model_keypoints = keypoints;
  // source_keypoints = model_keypoints;
  // source_cloud = point_cloud_ptr;

  keypoints->header.frame_id = point_cloud_ptr->header.frame_id;
  keypoints->header.stamp = point_cloud_ptr->header.stamp;

  pcl::PCLPointCloud2 pcl_pc2;
  pcl::toPCLPointCloud2(*keypoints, pcl_pc2);

  pub6.publish (pcl_pc2);

      /* SHOT estimation part */

    // pcl::SHOTEstimationOMP<pcl::PointXYZI, pcl::Normal, pcl::SHOT352> shot;
    // shot.setInputCloud (model_keypoints);
    // shot.setInputNormals (cloud_normals);
    // shot.setSearchMethod (tree);
    // shot.setSearchSurface (point_cloud_ptr);
    // pcl::PointCloud<pcl::SHOT352>::Ptr shotFeatures (new pcl::PointCloud<pcl::SHOT352> ());
    // shot.setRadiusSearch (1.75);
    // shot.compute (*shotFeatures);
    // // std::cout << shotFeatures->size () << std::endl;

    // for (size_t i = 0; i < shotFeatures->size (); ++i)
    // {
    //   if (std::isnan(shotFeatures->points[i].descriptor[0])){
    //     for (size_t j = 0; j<352; ++j){
    //       shotFeatures->points[i].descriptor[j]=0;
    //     }
    //   }
    // } 
    // // std::cout << shotFeatures->size () << std::endl;

    // source_cloud_keypoints = shotFeatures;

    // boost::shared_ptr<pcl::Correspondences> correspondences (new pcl::Correspondences);
    // pcl::registration::CorrespondenceEstimation<pcl::SHOT352, pcl::SHOT352> corr_est;
    // corr_est.setInputSource (source_cloud_keypoints);
    // corr_est.setInputTarget (target_cloud_keypoints);
    // corr_est.determineCorrespondences (*correspondences);
    // // std::cout << "Found " << correspondences->size() << " number of correspondences" << std::endl;

    // boost::shared_ptr<pcl::Correspondences> new_correspondences (new pcl::Correspondences);
    // pcl::registration::CorrespondenceRejectorDistance rej;
    // rej.setInputSource<pcl::PointXYZI> (source_keypoints);
    // rej.setInputTarget<pcl::PointXYZI> (target_keypoints);
    // rej.setMaximumDistance (7);    // 7m
    // rej.setInputCorrespondences (correspondences);
    // rej.getCorrespondences (*new_correspondences);

    // // std::cout << "Found " << new_correspondences->size() << " number of new correspondences" << std::endl;

    // // std::cout << "Size of first image: " << source_cloud->size() << " Size of second image: " << target_cloud->size() << std::endl;

    // pcl::registration::CorrespondenceRejectorSampleConsensus<pcl::PointXYZI> correspondence_rejector;
    // correspondence_rejector.setInputSource(source_keypoints);
    // correspondence_rejector.setInputTarget(target_keypoints);
    // correspondence_rejector.setInlierThreshold(0.2);
    // correspondence_rejector.setMaximumIterations(1000);
    // correspondence_rejector.setRefineModel(true);
    // correspondence_rejector.setInputCorrespondences(new_correspondences);

    // boost::shared_ptr<pcl::Correspondences> cor_inliers_ptr (new pcl::Correspondences);
    // correspondence_rejector.getCorrespondences(*cor_inliers_ptr);

    // // std::cout << "Correspondences remaining: " << cor_inliers_ptr->size() << std::endl;

    // Eigen::Matrix4f transformation; 
    // transformation = correspondence_rejector.getBestTransformation();

    // Eigen::Matrix3f current_rotation;
    // current_rotation << 1, 0, 0, 0, 1, 0, 0, 0, 1;
    // Eigen::Vector3f current_translation;
    // current_translation << 0, 0, 0;

    // if (counter != 0){
    //   if (cor_inliers_ptr->size() == 0 || cor_inliers_ptr->size() == new_correspondences->size() || transformation(0,3)>2 || transformation(1,3)>2 || transformation(2,3)>2 || transformation(0,0)<0.8){
    //   // if (true){
    //     Eigen::Matrix4f guess; 
    //     guess << 1, 0, 0, 0.2, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1;
    //     pcl::IterativeClosestPoint<pcl::PointXYZI, pcl::PointXYZI> icp;
    //     icp.setInputSource(source_cloud);
    //     icp.setInputTarget(target_cloud);
    //     icp.setMaximumIterations(30);
    //     icp.setMaxCorrespondenceDistance(5);
    //     icp.setRANSACOutlierRejectionThreshold(0.01);
    //     // icp.setTransformationEpsilon (1e-9);
    //     pcl::PointCloud<pcl::PointXYZI> Final;
    //     icp.align(Final);
    //     Eigen::Matrix4f current_transformation;
    //     current_transformation = icp.getFinalTransformation();
    //     Eigen::Matrix3f rotation;
    //     rotation << current_transformation(0,0), current_transformation(0,1), current_transformation(0,2),current_transformation(1,0), current_transformation(1,1), current_transformation(1,2),current_transformation(2,0), current_transformation(2,1), current_transformation(2,2);
    //     current_rotation = rotation;
    //     total_rotation = total_rotation * rotation;
    //     since_last_rotation = since_last_rotation * rotation; 
    //     Eigen::Vector3f translation;
    //     translation << current_transformation(0,3), current_transformation(1,3), current_transformation(2,3);
    //     current_translation = translation;
    //     total_translation = total_translation + total_rotation*translation;
    //     since_last_translation = since_last_translation + since_last_rotation*translation;
    //     // std::cout << "Slam counter: " << slam_counter << std::endl;
    //     // std::cout << since_last_rotation << std::endl;
    //     // std::cout << since_last_translation << std::endl;
    //     distance_since_last += sqrt(pow(current_transformation(0,3),2) + pow(current_transformation(1,3),2) + pow(current_transformation(2,3), 2));
    //     // std::cout << "has converged:" << icp.hasConverged() << " score: " <<
    //     // icp.getFitnessScore() << std::endl;
    //     // std::cout << icp.getFinalTransformation() << std::endl;
    //     // std::cout << "ICP: " << std::endl;
    //     // total_transformation = total_transformation * icp.getFinalTransformation();
    //     std::cout << point_cloud_ptr->header.stamp << ", " << total_translation(0) << ", " << total_translation(1) << ", " << total_translation(2) << ", " << acos(total_rotation(0,0)) << ", 1" << std::endl;
    //   } else {
    //     pcl::IterativeClosestPoint<pcl::PointXYZI, pcl::PointXYZI> icp2;
    //     icp2.setInputSource(source_cloud);
    //     icp2.setInputTarget(target_cloud);
    //     icp2.setMaximumIterations(1);
    //     icp2.setMaxCorrespondenceDistance(3);
    //     // icp2.setRANSACOutlierRejectionThreshold(0.01);
    //     icp2.setTransformationEpsilon (1e-9);
    //     pcl::PointCloud<pcl::PointXYZI> Final2;
    //     icp2.align(Final2, transformation);
    //     // total_transformation = total_transformation * icp2.getFinalTransformation();
    //     Eigen::Matrix4f current_transformation;
    //     current_transformation = icp2.getFinalTransformation();
    //     Eigen::Matrix3f rotation;
    //     rotation << current_transformation(0,0), current_transformation(0,1), current_transformation(0,2),current_transformation(1,0), current_transformation(1,1), current_transformation(1,2),current_transformation(2,0), current_transformation(2,1), current_transformation(2,2);
    //     current_rotation = rotation;
    //     total_rotation = total_rotation * rotation; 
    //     since_last_rotation = since_last_rotation * rotation; 
    //     Eigen::Vector3f translation;
    //     translation << current_transformation(0,3), current_transformation(1,3), current_transformation(2,3);
    //     current_translation = translation;
    //     total_translation = total_translation + total_rotation*translation;
    //     since_last_translation = since_last_translation + since_last_rotation*translation;
    //     // total_transformation = total_transformation * transformation;
    //     // std::cout << transformation << std::endl;
    //     distance_since_last += sqrt(pow(current_transformation(0,3),2) + pow(current_transformation(1,3),2) + pow(current_transformation(2,3), 2));
    //     // std::cout << "Slam counter: " << slam_counter << std::endl;
    //     // std::cout << since_last_rotation << std::endl;
    //     // std::cout << since_last_translation << std::endl;
    //     std::cout << point_cloud_ptr->header.stamp << ", " << total_translation(0) << ", " << total_translation(1) << ", " << total_translation(2) << ", " << acos(total_rotation(0,0)) << ", 2" << std::endl;
    //   }
    //   // std::cout << "Total translation: \n" << total_translation << std::endl;
    //   // std::cout << "Total rotation: \n" << total_rotation << std::endl;
    // }
    // target_cloud_keypoints = shotFeatures;
    // // target_cloud_keypoints = shape_context_features;
    // // target_cloud_keypoints = fpfhs;
    // target_keypoints = model_keypoints;
    // target_cloud = point_cloud_ptr;
}

void 
cloud_cb (const sensor_msgs::PointCloud2ConstPtr& cloud_msg)
{

    pcl::PCLPointCloud2 pcl_pc2;
    pcl_conversions::toPCL(*cloud_msg,pcl_pc2);
    pcl::PointCloud<pcl::PointXYZI>::Ptr temp_cloud(new pcl::PointCloud<pcl::PointXYZI>);
    pcl::fromPCLPointCloud2(pcl_pc2,*temp_cloud);

    // // std::cout << "Temp cloud: " << temp_cloud->width << std::endl;
    // total_clouds += 1;
    // total_points += temp_cloud ->size();
    // cout << "Average points per cloud: " << total_points/total_clouds << endl;

    pcl::PointCloud<pcl::PointXYZI>::Ptr cloud_filtered (new pcl::PointCloud<pcl::PointXYZI>);

    pcl::ConditionOr<pcl::PointXYZI>::Ptr range_cond (new pcl::ConditionOr<pcl::PointXYZI> ());
    range_cond->addComparison(pcl::FieldComparison<pcl::PointXYZI>::ConstPtr (new
    pcl::FieldComparison<pcl::PointXYZI> ("x", pcl::ComparisonOps::LT, -1.0)));
    range_cond->addComparison(pcl::FieldComparison<pcl::PointXYZI>::ConstPtr (new
    pcl::FieldComparison<pcl::PointXYZI> ("x", pcl::ComparisonOps::GT, 0.5)));
    range_cond->addComparison(pcl::FieldComparison<pcl::PointXYZI>::ConstPtr (new
    pcl::FieldComparison<pcl::PointXYZI> ("y", pcl::ComparisonOps::LT, -1.1)));
    range_cond->addComparison(pcl::FieldComparison<pcl::PointXYZI>::ConstPtr (new
    pcl::FieldComparison<pcl::PointXYZI> ("y", pcl::ComparisonOps::GT, 1.1)));
    // build the filter
    pcl::ConditionalRemoval<pcl::PointXYZI> condrem;
    condrem.setCondition(range_cond);
    condrem.setInputCloud(temp_cloud);
    // apply filter
    condrem.filter(*cloud_filtered);

    pcl::PointCloud<pcl::PointXYZI>::Ptr second_cloud_filtered (new pcl::PointCloud<pcl::PointXYZI>);

    pcl::RadiusOutlierRemoval<pcl::PointXYZI> outrem;
    // build the filter
    outrem.setInputCloud(cloud_filtered);
    outrem.setRadiusSearch(1);
    outrem.setMinNeighborsInRadius(3);
    // apply filter
    outrem.filter (*second_cloud_filtered);

    pcl::PointCloud<pcl::PointXYZI>::Ptr third_cloud_filtered (new pcl::PointCloud<pcl::PointXYZI>);

    pcl::VoxelGrid<pcl::PointXYZI> sor;
    sor.setInputCloud(second_cloud_filtered);
    sor.setLeafSize(0.1, 0.1, 0.1);
    // sor.setLeafSize(0.15, 0.15, 0.5);
    sor.filter(*third_cloud_filtered);

    // std::cout << "Third cloud: " << third_cloud_filtered->size() << std::endl;

    // narf(third_cloud_filtered);
    // sift(third_cloud_filtered);
    iss(third_cloud_filtered);
    // harris(third_cloud_filtered);
    // ndt(third_cloud_filtered);
    // iss_time(third_cloud_filtered);

    // pcl::PCLPointCloud2 pcl_pc;
    // pcl::toPCLPointCloud2(*third_cloud_filtered, pcl_pc);
    // file << north << ", " << east << ", " << 0 << endl;

    // pub.publish (pcl_pc);
}

void test(const sensor_msgs::PointCloud2ConstPtr& cloud_msg){
  std::cout << "Test" << std::endl;
}

void fix_pose(const geometry_msgs::PoseStamped pose_msg){
  std::cout << pose_msg << std::endl;
}

void navi_test(const my_pcl_tutorial::NorthEastHeading& nav_msg){
  north = nav_msg.north;
  east = - nav_msg.east;
  theta = - nav_msg.heading;
  nav_online = true;
  // cout << "Theta: " << theta << endl;
}

int
main (int argc, char** argv)
{
  pcl::console::setVerbosityLevel(pcl::console::L_ALWAYS);
  // Initialize ROS
  ros::init (argc, argv, "my_pcl_tutorial");
  ros::NodeHandle nh;
  ros::NodeHandle nh2;
  // total_transformation << cos(0.82897903482), sin(0.82897903482), -0.645953733353, 0, -sin(0.82897903482), cos(0.82897903482), 2.79517319837, 0, 0, 0, 1, 0, 0, 0, 0, 1;
  since_last_transformation << 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1;
  total_rotation << cos(0.83), sin(0.83), 0, -sin(0.83), cos(0.83), 0, 0, 0, 1;
  total_translation << -0.645953733353, 2.79517319837, 0;
  since_last_rotation << 1, 0, 0, 0, 1, 0, 0, 0, 1;
  since_last_translation << 0, 0, 0;
  // viewer->setBackgroundColor (0, 0, 0);
  file.open("GPS_for_odometry");
  odom_file.open("Odometry");

  // Create a ROS subscriber for the input point cloud
  ros::Subscriber sub = nh.subscribe ("/velodyne_points", 1, cloud_cb);

  ros::Subscriber sub2 = nh.subscribe ("/Correct_pose", 1, fix_pose);

  ros::Subscriber sub3 = nh.subscribe("/navigation/eta", 1, navi_test);

  // Create a ROS publisher for the output point cloud
  pub = nh.advertise<sensor_msgs::PointCloud2> ("filtered_cloud", 1);

  pub2 = nh.advertise<sensor_msgs::PointCloud2> ("NARF_keypoints", 1);

  pub3 = nh.advertise<sensor_msgs::PointCloud2> ("SIFT_keypoints", 1);

  pub4 = nh.advertise<sensor_msgs::PointCloud2> ("ISS_keypoints", 1);

  pub5 = nh.advertise<sensor_msgs::PointCloud2> ("Matching_points", 1);

  pub6 = nh.advertise<sensor_msgs::PointCloud2> ("Harris_keypoints", 1);

  pub7 = nh.advertise<geometry_msgs::PoseStamped> ("Pose_test", 1);

  pub8 = nh.advertise<geometry_msgs::PointStamped> ("Point_test", 1);

  pub9 = nh.advertise<sensor_msgs::PointCloud2> ("Loop", 1);

  pub10 = nh.advertise<sensor_msgs::PointCloud2> ("Loop_closure", 1);

  pub11 = nh.advertise<sensor_msgs::PointCloud2> ("Loop_closure2", 1);

  // Spin
  ros::spin ();
}